cgi_name	WebDataplot
                               
#  COMMON DEFINITIONS FOR ALL WEB PAGES
#  CHANGE THEM FOR YOUR SITE AS NECESSARY OR AS DESIRED
                               
#--------------------------------------------------------------------------------

#  If debugging is enabled, then errors in the CGI scripts are reported
#  on the web page.  If debugging is disabled, then errors are email to
#  the cgi.tcl ADMIN person defined below.
#  Uncomment the next line to enable debugging.

#cgi_debug	-on

#--------------------------------------------------------------------------------

#  Links about cgi.tcl administrator.  This should be the person at your
#  site who maintains the CGI scripts and/or the cgi.tcl library.  If an
#  error occurs in a CGI script and debugging is off, then this person will
#  receive and email message detailing the error in the script.  The link
#  to the person's email address appears at the bottom of every web page.

cgi_admin_mail_addr	robert.lipman@nist.gov
#cgi_link ADMIN		"Robert Lipman"	mailto:[cgi_admin_mail_addr]
cgi_link ADMIN		"Robert Lipman"	http://www.nist.gov/cgi-bin/wwwph?Robert+Lipman

#--------------------------------------------------------------------------------

#  Links about script author and their organization.  These links appear at
#  the bottom of every web page.  These shouldn't be changed so that the
#  original author gets credit.

#cgi_link AUTHOR	"Robert Lipman"	http://www.nist.gov/cgi-bin/wwwph?Robert+Lipman
cgi_link AUTHOR	"Robert Lipman"	http://cic.nist.gov/lipman/
cgi_link ORG1   "NIST"		http://www.nist.gov/
cgi_link ORG2   "ITL (formerly)"	http://www.itl.nist.gov/
cgi_link ORG3   "BFRL (currently)"	http://www.bfrl.nist.gov/

#--------------------------------------------------------------------------------

#  Application or site specific links

cgi_link DATAPLOT "Dataplot"	 http://www.itl.nist.gov/div898/software/dataplot/
cgi_link TCL	  "Tcl" 	 http://dev.scriptics.com/
cgi_link TCLCGI   "cgi.tcl"	 http://expect.nist.gov/cgi.tcl/
cgi_link EXPECT   "Expect"	 http://expect.nist.gov/
cgi_link GNUPLOT  "Gnuplot"	 http://www.ece.curtin.edu.au:80/~bvk/plot/gnuplot.html

set EXPECT_HOST http://expect.nist.gov
set EXPECT_ART  $EXPECT_HOST/art
set CGITCL      $EXPECT_HOST/cgi.tcl/
cgi_imglink LOGO  $EXPECT_ART/cgitcl-powered-feather.gif align=left "alt=powered-by-cgi.tcl logo"
cgi_link LOGOLINK [cgi_imglink LOGO] $CGITCL

#--------------------------------------------------------------------------------

set env(DATAPLOT_WEB) TRUE

set sample(0) {"CALL LAGPLOT.DP"
"CALL STARPLOT.DP"
"CALL PLANETS.DP"
"CALL YOUDPLOT.DP"
"CALL 3DNOPLOT.DP"
"CALL BOXPLOT.DP"
"CALL FFTPLOT.DP"
"CALL GANOVA3.DP"
"CALL HAMAKER.DP"
"CALL MULTITRA.DP"
"CALL PARCOORD.DP"
"CALL PDFPLOT.DP"
"CALL PNCC.DP"
"CALL PROFPLOT.DP"
"CALL QUANPLOT.DP"
"CALL SPECPLOT.DP"
"CALL SPIKEPLO.DP"
"CALL PERIODIC.DP"
"CALL DATAPLOT.DP"}     

set sample(1) ". This is Dataplot program file    WOMELDOR.DP
. Fit of refridgerant flame extinquishment data
.
. -----start point-----
.
. Step 1--Generate simulated data
.
DIMENSION 40 VARIABLES
LET F = DATA 1 1.1 1.2 2 2.1 2.2 3 3.1 3.2 4 4.1 4.2 5 5.1 5.2
LET A = 4.71*F
LET N = NUMBER F
LET Z = NORMAL RANDOM NUMBERS FOR I = 1 1 N
LET Z = Z*(.01/2)
LET F = F+Z
PLOT F A
.
. Step 2--Form variables F/A and F+A
.
LET Y = (F/A)*4.76
LET X = (F+A)*12.26
PLOT Y X
.
. Step 3--Carry out a linear fit
.
LINEAR FIT Y X
.
. Step 4--Define the non-linear function
.
LET FUNCTION NUM = A*(ALPHA+12.26*BETA*A)
LET FUNCTION DEN = 4.76-12.26*BETA*A
LET FUNCTION RATIO = NUM/DEN
.
. Step 5--Carry out the non-linear fit
.
FIT F = RATIO
.
. Step 6--Do simulation and monitor the estimated alpha values
.
LOOP FOR K = 1 1 10
   LET FORIG = F
   LET AORIG = A
   LET FERROR = NORMAL RANDOM NUMBERS FOR I = 1 1 N
   LET FERROR = (.01/2)*FERROR
   LET AERROR = NORMAL RANDOM NUMBERS FOR I = 1 1 N
   LET AERROR = (0.047/2)*AERROR
. LET F = FORIG+(.01/2)*FORIG*FERROR
   LET F = FORIG+FERROR
   LET A = AORIG+AERROR
   FIT F = RATIO
   LET ALPHAVEC(K)=ALPHA
   LET RESSDVEC(K)=RESSD
END LOOP
HISTOGRAM ALPHAVEC
HISTOGRAM RESSDVEC
EXIT"

set sample(2) ". THIS IS DATAPLOT MACRO MULTSCPL.DP
. PURPOSE--GENERATE UPPER TRIANGLE SCATTER PLOT MULTIPLOT
.
. -----START POINT-----
.
LET X = 1 1 10
LET Y1 = X
LET Y2 = X**2
LET Y3 = X**3
.
LINES BLANK ALL
FRAME CORNER COORDINATES 0 0 100 100
TICS OFF
TIC LABELS OFF
LEGEND 1 JUSTIFICATION CENTER
LEGEND 1 COORDINATES 50 50
.
LET STRING S1 = APPLES
LET STRING S2 = ORANGES
LET STRING S3 = BANANAS
.
LET N = 3
LET NM1 = N-1
LET N2 = 2*N
LEGEND SIZE N2
CHARACTER SIZE N2
MULTIPLOT N N
LOOP FOR J = 1 1 N
   LOOP FOR K = I 1 N
      IF K = J
         MULTIPLOT N N J K
         CHAR BLANK ALL
         LEGEND 1 ^S^J
         PLOT Y^J Y^K
      END IF
      IF K > J
         MULTIPLOT N N J K
         LEGEND 1
         CHAR X ALL
         PLOT Y^J Y^K
      END IF
   END LOOP
END LOOP
EXIT"

set sample(3) "DELETE Y\nSKIP 25\nREAD SUNSPOT2.DAT Y\n4-PLOT Y\nEXIT"

set sample(4) ""

#-------------------------------------------------------------------------------

#  macros for Dataplot handbook

set macro(4PLOT) "DELETE Y
SKIP 25
READ MAVRO.DAT Y
4-PLOT Y"

set macro(pontius_udm.dp) "feedback off
justification center
y1label offset 10
title offset 3
lines blank solid
char x
skip 0
read /home/fs3a/guthrie/pontius.dat y x
title Your Data - Load Cell Calibration Macro
x2label x
y1label y
plot y x
system sleep 3
linear fit y x
title Your Data with Straight Line Model
x2label x
y1label y
plot y pred vs x
system sleep 3
let residuals = res
title Residuals from Straight Line Fit vs x
x2label x
y1label Residuals
plot res x
system sleep 3
title Residuals from Straight Line Fit vs Predicted Values
x2label Predicted Values 
y1label Residuals
plot res pred 
system sleep 3
title automatic 
x2label  
ylabel
4plot residuals
system sleep 5
quadratic fit y x
title Your Data with Quadratic Model
x2label x
y1label y
plot y pred vs x
system sleep 5
let residuals = res
title Residuals from Quadratic Fit vs x
x2label x
y1label Residuals
plot res x
system sleep 3
title Residuals from Quadratic Fit vs Predicted Values 
x2label Predicted Values 
y1label Residuals
plot res pred 
system sleep 3
title automatic 
x2label  
ylabel
4plot residuals
feedback on"

set macro(shewhartchart.dp) "y1label displacement 10 
read /home/fs3a/guthrie/moshe2.dat time y
let ybar = mean y
let s = standard deviation y
let ucl = y - y + ybar + 2*s
let center = y - y + ybar
let lcl = y - y + ybar - 2*s
title Shewhart Control Chart of Your Data
characters * blank blank blank
lines blank dashed solid dashed
y1label y
x1label time
x2label 2-sigma limits
plot y ucl center lcl vs time"


################################################################################

#  Common Tcl/CGI code definition for the TOP of every web page

proc app_body_start {} {

#  linked image, 2 spaces, title
   cgi_h2 align=center [cgi_title]

#  horizontal rule
   cgi_hr noshade
}

################################################################################

#  Common Tcl/CGI code definition for the BOTTOM of every web page

proc app_body_end {} {

#  horizontal rule, break
   cgi_hr noshade
   cgi_br
   
#  who to contact with problems, break
   puts "For problems or questions about WebDataplot contact: [cgi_link AUTHOR]"
   cgi_br
   
#  Tcl version
   puts "[cgi_link TCL] version: [info patchlevel],  [cgi_link EXPECT] version: [exp_version],  [cgi_link TCLCGI] version: [package versions cgi]"
   
#  script author
#   puts "Written by: [cgi_link AUTHOR], [cgi_link ORG3], [cgi_link ORG2], [cgi_link ORG1]"
   
#  execute Unix date command to get the time the script was executed
   ExecCmd date
   
#  logo
   puts [cgi_link LOGOLINK]
}
